// Ingame controller

// snake stuff
struct snake_segment
{
	s8 x;
	s8 y;
};
struct snake_segment snake_pieces[500];
u16 snake_len = 0;
#define snake_max 500
#define snake_min 4

u8 snake_dir; // 0-Left, 1-Up, 2-Right, 3-Down
u32 snake_movet = 0;
u32 snake_speed;

// rat stuff
u8 rat_x;
u8 rat_y;
int game_rats = 0;
bool rat_enable;

// fruit stuff
u8 fruit_x;
u8 fruit_y;
u8 fruit_type;
u32 fruit_time;
u32 fruit_spawn_time;
bool fruit_enable;

// powerup stuff
u8 power_x;
u8 power_y;
u32 power_time;
u32 power_spawn_time;
bool power_enable;

bool bGetPower;
u32 getpower_time;

// multiplier
u8 score_multi = 1;
int score_multi_time = 0;
u8 score_multi_old = 1;
bool score_multi_streak = false;

bool game_pause;

bool bGame_Start;
bool bGame_Ready;
int game_rdy_time;
bool game_bDead;
int game_over_time;

bool game_bClickA;
bool game_bClickD;
bool game_bClickS;

bool bCheated;

u16 game_lives;
u16 game_level;
u32 game_score;

u16* game_bg1Data = (u16*)0x6002800;
u16* game_bg3Data = (u16*)0x6007800;
u8* game_map  = (u8*)0x2000000;
u8* game_mapm = (u8*)0x20003DC;

//extern "C" void game_reset_bg();
void game_init_bg(void);
void game_redraw_stats(void);
void game_LoadMap(u8* adr);
void Draw_Level(void);
void game_getinput(void);
void game_reset_snake(void);
void game_erase_snake(void);
void Snake_ToggleSegment(int x, int y);
void Snake_DrawSegment(int x, int y);
void Snake_EraseSegment(int x, int y);
void Snake_DrawWhole(void);
void Snake_Move(void);
void Snake_Refresh(void);
void Snake_Reset(void);
void Snake_SetDir(u8 dir);
void game_CleanOAM(void);

void Place_Rat(void);
void Draw_Rat(void);
void Erase_Rat(void);
void Snake_EatRat(void);

void Fruit_Place(void);
void Fruit_Rid(void);
void Fruit_Reset_Spawn(void);
void Snake_EatFruit(void);

void Power_Place(void);
void Power_Rid(void);
void Power_Reset_Spawn(void);
void Snake_GetPower(void);

void game_CleanOAM(void)
{
	u32 loop;
	for (loop = 32*16; loop < 1024*16; loop++)
		OAMData[loop] = 0;
}

void Start_Game(void)
{
	REG_DISPCNT &= 0xFFFF - BG1_ENABLE;
	ClearSprites();
	CopyOAM();
	REG_BG3CNT = 0xF05;
	REG_BG3HOFS = 256 - 44;
	REG_BG3VOFS = 256 - 36;
	REG_BG1CNT = 0x504;
	REG_BG1HOFS = 256 - 44;
	REG_BG1VOFS = 256 - 36;
	game_CleanOAM();
	copy2obj((u8*)gfx_game_shell, (u16*)0x6003000, 160, 128, true);
	copy2obj((u8*)gfx_game_blocks, (u16*)0x6008000, 128, 8, false);
	copy2obj((u8*)gfx_game_numb, (u16*)0x6010400, 80, 8, false);
	copy2obj((u8*)gfx_game_life, (u16*)0x6010800, 16, 8, false);
	copy2obj((u8*)gfx_game_fruit, (u16*)0x6010840, 32, 8, true);
	copy2obj((u8*)gfx_game_pickup, (u16*)0x6010c00, 8, 8, false);
	copy2obj((u8*)gfx_game_rat, (u16*)0x6010c20, 8, 8, false);
	copy2obj((u8*)gfx_game_start, (u16*)0x6011000, 64, 64, false);
	copy2obj((u8*)gfx_game_ready, (u16*)0x6011100, 48, 8, true);
	copy2obj((u8*)gfx_game_over, (u16*)0x6011500, 120, 8, true);

	copy2obj((u8*)gfx_pu_1up, (u16*)0x6013400, 40, 8, true);
	copy2obj((u8*)gfx_pu_faster, (u16*)0x6013800, 56, 8, true);
	copy2obj((u8*)gfx_pu_slower, (u16*)0x6013C00, 48, 8, true);
	copy2obj((u8*)gfx_pu_10p, (u16*)0x6014000, 24, 8, true);
	copy2obj((u8*)gfx_pu_50p, (u16*)0x6014400, 24, 8, true);
	copy2obj((u8*)gfx_pu_100p, (u16*)0x6014800, 32, 8, true);
	copy2obj((u8*)gfx_pu_200p, (u16*)0x6014C00, 32, 8, true);
	copy2obj((u8*)gfx_pu_500p, (u16*)0x6015000, 40, 8, true);
	copy2obj((u8*)gfx_pu_x2, (u16*)0x6015400, 16, 8, true);
	copy2obj((u8*)gfx_pu_x5, (u16*)0x6015800, 16, 8, true);
	copy2obj((u8*)gfx_pu_x10, (u16*)0x6015C00, 24, 8, true);
	copy2obj((u8*)gfx_pu_longer, (u16*)0x6016000, 56, 8, true);
	copy2obj((u8*)gfx_highscore, (u16*)0x6016400, 88, 8, true);
	copy2obj((u8*)gfx_pause, (u16*)0x6016800, 40, 8, true);
	game_ResetCounters();
	game_LoadMap((u8*)maparr[game_level]);
	//game_bg3Data[0] = 522;
	game_init_bg();
	game_reset_bg();
	game_reset_snake();
	//REG_DISPCNT |= BG3_ENABLE;
	game_redraw_stats();
	SetSprite_64x64(40+58, 16+52, 128, 13);
	//game_LoadMap((u8*)map_testmap);
	Draw_Level();
	bGame_Start = true;
	bGame_Ready = true;
	game_bClickA = true;
	game_bClickS = true;
	rat_enable = false;
	fruit_enable = false;
	Fruit_Reset_Spawn();
	Power_Reset_Spawn();
	Snake_Reset();
	bGetPower = false;
	game_pause = false;
	while (1)
	{
		if (!bGame_Start && !bGame_Ready)
		{
			if (game_pause)
			{
				if (!game_bClickS && KeyState(KEY_START))
				{
					game_bClickS = true;
					SetSprite_32x8(240, 160, 0, 0);
					SetSprite_8x8(240, 160, 0, 1);
					game_pause = false;
				}
				if (!KeyState(KEY_START)) game_bClickS = false;
				goto skipstuff;
			}
			if (bGetPower)
			{
				getpower_time--;
				if (getpower_time == 0)
				{
					bGetPower = false;
					SetSprite_32x8(240, 160, 0, 0);
					SetSprite_32x8(240, 160, 0, 1);
				}
				goto skipstuff;
			}
			if (score_multi > 1)
			{
				score_multi_time--;
				if (score_multi_time <= 0)
				{
					score_multi_time = 0;
					score_multi = 1;
				}
			}
			if (!fruit_enable)
			{
				fruit_spawn_time--;
				if (fruit_spawn_time <= 0) Fruit_Place();
			}
			else
			{
				fruit_time--;
				if (fruit_time <= 0)
				{
					Fruit_Rid();
					fruit_enable = false;
					Fruit_Reset_Spawn();
				}
			}
			if (!power_enable)
			{
				power_spawn_time--;
				if (power_spawn_time <= 0) Power_Place();
			}
			else
			{
				power_time--;
				if (power_time <= 0)
				{
					Power_Rid();
					power_enable = false;
					Power_Reset_Spawn();
				}
			}
			if (!rat_enable)
			{
				Place_Rat();
				Draw_Rat();
				rat_enable = true;
			}
			Snake_Refresh();
			if (game_bDead)
			{
				game_lives--;
				game_redraw_stats();
				game_rdy_time = 150;
				bGame_Ready = true;
				game_bDead = false;
				if (game_lives == 0)
				{
					game_over_time = 120;
					SetSprite_32x8(100, 84, 168, 14);
					SetSprite_8x8(132, 84, 172, 15);
					while (1)
					{
						game_over_time--;
						if (game_over_time <= 0)
						{
							game_over_time = 175;
							SetSprite_32x8(80, 84, 173, 14);
							SetSprite_32x8(112, 84, 177, 15);
							SetSprite_16x8(144, 84, 181, 16);
							while (1)
							{
								game_over_time--;
								if (game_over_time <= 0)
								{
									if (bCheated) game_score = 0;
									game_over_time = 0;
									bool bHighScore;
									int hs_flash = 0;
									bHighScore = Check_HighScore(game_score);
									game_bClickA = true;
									
									while (1)
									{
										if (bHighScore)
										{
											hs_flash++;
											if (hs_flash == 30)
											{
												SetSprite_32x8(76, 84, 800, 14);
												SetSprite_32x8(108, 84, 804, 15);
												SetSprite_32x8(140, 84, 808, 16);
												Snd_Stop();
												Snd_Beep(5, 0, 7, 3, 2, 6, 0, 0xF, 0x760);
											}
											else if (hs_flash == 60)
											{
												hs_flash = 0;
												SetSprite_32x8(240, 160, 0, 14);
												SetSprite_32x8(240, 160, 0, 15);
												SetSprite_32x8(240, 160, 0, 16);
											}
										}
										if (KeyState(KEY_A) && !game_bClickA)
										{
											Snd_Stop();
											Snd_Beep(5, 0, 5, 3, 2, 1, 0, 0xF, 0x700);
											if (bHighScore)
											{
												Enter_Highscore();
											}
											goto exitgame;
										}
										if (!KeyState(KEY_A)) game_bClickA = false;
										CopyOAM();
										WaitForVSync();
									}
								}
								CopyOAM();
								WaitForVSync();
							}
						}
						CopyOAM();
						WaitForVSync();
					}
				}
				else
				{
					game_erase_snake();
					Snake_Reset();
					
					SetSprite_32x8(96, 44, 136, 14);
					SetSprite_16x8(128, 44, 140, 15);
					Snake_DrawWhole();
				}
			}
		}
		game_getinput();
skipstuff:
		CopyOAM();
		WaitForVSync();
	}
exitgame:
	REG_DISPCNT = MODE_0 | BG2_ENABLE | OBJ_ENABLE | OBJ_MAP_2D;
	ClearSprites();
	CopyOAM();
}

void game_getinput(void)
{
	if (bGame_Start)
	{
		if (!game_bClickA && KeyState(KEY_A))
		{
			SetSprite_8x8(240, 160, 0, 13);
			REG_DISPCNT |= BG3_ENABLE;
			REG_DISPCNT |= BG1_ENABLE;
			Snake_Reset();
			SetSprite_32x8(96, 44, 136, 14);
			SetSprite_16x8(128, 44, 140, 15);
			bGame_Ready = true;
			bGame_Start = false;
			game_rdy_time = 150;
			Snake_DrawWhole();
			
		}
	}
	else if (bGame_Ready)
	{
		game_rdy_time--;
		if (game_rdy_time <= 0)
		{
			bGame_Ready = false;
			SetSprite_8x8(240,160,0, 14);
			SetSprite_8x8(240,160,0, 15);
		}
	}
	else
	{
		if (!game_bClickS && KeyState(KEY_START) && !bGetPower)
		{
			game_bClickS = true;
			SetSprite_32x8(100, 84, 832, 0);
			SetSprite_8x8(132, 84, 836, 1);
			game_pause = true;
		}
		if (!game_bClickA && KeyState(KEY_A))
		{
			game_bClickA = true;
		}
		if (KeyState(KEY_LEFT))
			Snake_SetDir(0);
		else if (KeyState(KEY_UP))
			Snake_SetDir(1);
		else if (KeyState(KEY_RIGHT))
			Snake_SetDir(2);
		else if (KeyState(KEY_DOWN))
			Snake_SetDir(3);
	}
	if (!KeyState(KEY_A)) game_bClickA = false;
	if (!KeyState(KEY_START)) game_bClickS = false;
}

void game_erase_snake(void)
{
	u32 x, y;
	for (x = 0; x < 19; x++)
		for (y = 0; y < 13; y++)
			game_bg1Data[x + y * 32] = 512 + (1 << 12);
}

void game_reset_snake(void)
{
	u32 x, y;
	for (x = 0; x < 32; x++)
		for (y = 0; y < 32; y++)
			game_bg1Data[x + y * 32] = 21;
	for (x = 0; x < 19; x++)
		for (y = 0; y < 13; y++)
			game_bg1Data[x + y * 32] = 512 + (1 << 12);
}

void game_redraw_stats(void)
{
	SetSprite_8x8(40+146, 16+6, 32 + (game_score % 10), 25);
	SetSprite_8x8(40+146 - 8, 16+6, 32 + (game_score % 100) / 10, 26);
	SetSprite_8x8(40+146 - 16, 16+6, 32 + (game_score % 1000) / 100, 27);
	SetSprite_8x8(40+146 - 24, 16+6, 32 + (game_score % 10000) / 1000, 28);
	SetSprite_8x8(40+146 - 32, 16+6, 32 + (game_score % 100000) / 10000, 29);
	SetSprite_8x8(40+146 - 40, 16+6, 32 + (game_score % 1000000) / 100000, 30);
	SetSprite_8x8(40+146 - 48, 16+6, 32 + (game_score % 10000000) / 1000000, 31);
	
	SetSprite_8x8(40+81, 16+6, 32 + ((game_level % 10)), 7);
	SetSprite_8x8(40+73, 16+6, 32 + ((game_level % 100) / 10), 8);
	if (game_lives >= 1)
		SetSprite_8x8(40+5, 16+7, 65, 9);
	else
		SetSprite_8x8(40+5, 16+7, 64, 9);
	if (game_lives >= 2)
		SetSprite_8x8(40+13, 16+7, 65, 10);
	else
		SetSprite_8x8(40+13, 16+7, 64, 10);
	if (game_lives >= 3)
		SetSprite_8x8(40+21, 16+7, 65, 11);
	else
		SetSprite_8x8(40+21, 16+7, 64, 11);
	if (game_lives >= 4)
		SetSprite_8x8(40+29, 16+7, 65, 12);
	else
		SetSprite_8x8(40+29, 16+7, 64, 12);
}

void game_init_bg(void)
{
	u32 x, y;
	for (x = 0; x < 32; x++)
		for (y = 0; y < 32; y++)
			game_bg3Data[x + y * 32] = 21;
}

void game_reset_bg(void)
{
	u32 x, y;
	for (x = 0; x < 19; x++) // 19
	{
		for (y = 0; y < 13; y++) // 13
		{
			game_bg3Data[x + y * 32] = 512 + (1 << 12);
		}
	}
}

void game_ResetCounters(void)
{
	game_lives = 2;
	game_level = 0;
	game_score = 0;
	game_rats = 0;
	bCheated = false;
	if (KeyState(KEY_LEFT) && KeyState(KEY_L) && KeyState(KEY_R))
	{
		game_level = 7;
		bCheated = true;
	}
}

void game_LoadMap(u8* adr)
{
	
	u32 loop;
	for (loop = 0; loop < 988; loop++)
	{
		game_map[loop] = (adr[(loop / 8)] >> (loop % 8)) & 1;
	}
	for (loop = 988; loop < 1976; loop++)
	{
		game_mapm[loop-988] = (adr[(loop / 8)] >> (loop % 8)) & 1;
	}
	
	//copy2obj(adr, (u16*)0x2000000, 38, 28, false);
}

void Draw_Level(void)
{
	u32 x, y;
	u16 tile = 0;
	
	for (y = 0; y < 26; y++)
		for (x = 0; x < 38; x++)
		{
			if (game_map[x + y * 38] == 1)
			{
				tile = 1 << ((x % 2) + (y % 2) * 2);
			}
			game_bg3Data[(x / 2) + (y / 2) * 32] |= tile;
			tile = 0;
		}
}

void Snake_ToggleSegment(int x, int y)
{
	u16 tile;
	tile = 1 << ((x % 2) + (y % 2) * 2);
	game_bg1Data[(x / 2) + (y / 2) * 32] ^= tile;
}

void Snake_DrawSegment(int x, int y)
{
	if (x >= 38 && y >= 26) return;
	if (x < 0 || y < 0 || x >= 38 || y >= 26) return;
	u16 tile;
	tile = 1 << ((x % 2) + (y % 2) * 2);
	game_bg1Data[(x / 2) + (y / 2) * 32] |= tile;
}

void Snake_EraseSegment(int x, int y)
{
	u16 tile;
	tile = 1 << ((x % 2) + (y % 2) * 2);
	game_bg1Data[(x / 2) + (y / 2) * 32] &= 0xFFFF - tile;
}

void Snake_Reset(void)
{
	snake_len = snake_min;
	int loop;
	for (loop = 0; loop < snake_max; loop++)
	{
		snake_pieces[loop].x = 38;
		snake_pieces[loop].y = 26;
	}
	for (loop = 0; loop < snake_min; loop++)
	{
		snake_pieces[loop].x = 18;
		snake_pieces[loop].y = 12;
	}
	snake_dir = 2;
	snake_movet = 0;
	snake_speed = 45;
}

void Snake_Refresh(void)
{
	snake_movet += snake_speed;
	if (snake_movet >= 512)
	{
		Snake_Move();
		snake_movet -= 512;
	}
	if (snake_pieces[0].x == rat_x && snake_pieces[0].y == rat_y && rat_enable) Snake_EatRat();
	if ((snake_pieces[0].x == fruit_x || snake_pieces[0].x == fruit_x + 1) && (snake_pieces[0].y == fruit_y || snake_pieces[0].y == fruit_y + 1) && fruit_enable) Snake_EatFruit();
	if ((snake_pieces[0].x == power_x || snake_pieces[0].x == power_x + 1) && (snake_pieces[0].y == power_y || snake_pieces[0].y == power_y + 1) && power_enable) Snake_GetPower();
}

void Snake_EatRat(void)
{
	Snd_Stop();
	Snd_Beep(1, 0, 4, 0x10, 2, 7, 0, 0xC, 0x500);
	Place_Rat();
	game_score += 50 * score_multi;
	Draw_Rat();
	game_redraw_stats();
	if (snake_len < snake_max) snake_len++;
	game_rats++;
	if (game_rats >= 20 && game_level < 7)
	{
		game_level++;
		game_score += 200;
		game_rats = 0;
		game_reset_snake();
		rat_enable = false;
		Erase_Rat();
		Fruit_Rid();
		Power_Rid();
		fruit_enable = false;
		Fruit_Reset_Spawn();
		Power_Reset_Spawn();
		Snake_Reset();
		bGame_Ready = true;
		game_rdy_time = 150;
		Snake_DrawWhole();
		SetSprite_32x8(96, 44, 136, 14);
		SetSprite_16x8(128, 44, 140, 15);
		game_LoadMap((u8*)maparr[game_level]);
		game_reset_bg();
		Draw_Level();
		game_redraw_stats();
	}
}

void Snake_Move(void)
{
	int loop;
	Snake_EraseSegment(snake_pieces[snake_len - 1].x, snake_pieces[snake_len - 1].y);
	for (loop = snake_len - 1; loop > 0; loop--)
	{
		snake_pieces[loop].x = snake_pieces[loop - 1].x;
		snake_pieces[loop].y = snake_pieces[loop - 1].y;
	}
	switch (snake_dir)
	{
	case 0:
		snake_pieces[0].x -= 1;
		break;
	case 1:
		snake_pieces[0].y -= 1;
		break;
	case 2:
		snake_pieces[0].x += 1;
		break;
	case 3:
		snake_pieces[0].y += 1;
		break;
	}
	Snake_DrawSegment(snake_pieces[0].x, snake_pieces[0].y);
	Snake_DrawSegment(snake_pieces[snake_len-1].x, snake_pieces[snake_len-1].y);
	if (snake_pieces[0].x < 0 || snake_pieces[0].x > 37 || snake_pieces[0].y < 0 || snake_pieces[0].y > 25)
	{
		game_bDead = true;
		Snd_Stop();
		Snd_Beep(2, 0, 6, 3, 2, 6, 0, 0xF, 0x680);
		goto skiprest;
	}
	if (game_map[snake_pieces[0].x + snake_pieces[0].y * 38] == 1)
	{
		// The snake collided with a wall
		game_bDead = true;
		Snd_Stop();
		Snd_Beep(2, 0, 6, 3, 2, 6, 0, 0xF, 0x680);
	}
	for (loop = 1; loop < snake_len; loop++)
	{
		if (snake_pieces[0].x == snake_pieces[loop].x)
		{
			if (snake_pieces[0].y == snake_pieces[loop].y)
			{
				// The snake crashed into itself
				game_bDead = true;
				Snd_Stop();
				Snd_Beep(2, 0, 6, 3, 2, 6, 0, 0xF, 0x680);
			}
		}
	}
skiprest:;
}

void Snake_SetDir(u8 dir)
{
	switch(dir)
	{
	case 0:
		if (snake_pieces[1].x == snake_pieces[0].x - 1 && snake_pieces[1].y == snake_pieces[0].y) return;
		break;
	case 1:
		if (snake_pieces[1].x == snake_pieces[0].x && snake_pieces[1].y == snake_pieces[0].y - 1) return;
		break;
	case 2:
		if (snake_pieces[1].x == snake_pieces[0].x + 1 && snake_pieces[1].y == snake_pieces[0].y) return;
		break;
	case 3:
		if (snake_pieces[1].x == snake_pieces[0].x && snake_pieces[1].y == snake_pieces[0].y + 1) return;
		break;
	}
	snake_dir = dir;
}

void Snake_DrawWhole(void)
{
	int loop;
	for (loop = 0; loop < snake_len; loop++)
	{
		Snake_DrawSegment(snake_pieces[loop].x, snake_pieces[loop].y);
	}
}

void Place_Rat(void)
{
redoplace:
	rat_x = rand() % 38;
	rat_y = rand() % 26;
	if (game_mapm[rat_x + rat_y * 38] == 0) goto redoplace;
	if (game_map[rat_x + rat_y * 38] == 1) goto redoplace;
	u32 loop;
	for (loop = 0; loop < snake_len; loop++)
	{
		if (rat_x == snake_pieces[loop].x && rat_y == snake_pieces[loop].y) goto redoplace;
	}
	if (rat_x == power_x && rat_y == power_y && power_enable) goto redoplace;
	if (rat_x == power_x + 1 && rat_y == power_y && power_enable) goto redoplace;
	if (rat_x == power_x && rat_y == power_y + 1 && power_enable + 1) goto redoplace;
	if (rat_x == power_x + 1 && rat_y == power_y + 1 && power_enable + 1) goto redoplace;

	if (rat_x == fruit_x && rat_y == fruit_y && fruit_enable) goto redoplace;
	if (rat_x == fruit_x + 1 && rat_y == fruit_y && fruit_enable) goto redoplace;
	if (rat_x == fruit_x && rat_y == fruit_y + 1 && fruit_enable + 1) goto redoplace;
	if (rat_x == fruit_x + 1 && rat_y == fruit_y + 1 && fruit_enable + 1) goto redoplace;
}

void Draw_Rat(void)
{
	SetSprite_8x8(44 + rat_x * 4, 36 + rat_y * 4, 97, 16);
}

void Erase_Rat(void)
{
	SetSprite_8x8(240, 160, 0, 16);
}

// Fruit functions

void Fruit_Place(void)
{
	// Put the fruit on the screen
redoplace:
	fruit_x = rand() % 37;
	fruit_y = rand() % 25;
	if (game_mapm[(fruit_x) + (fruit_y) * 38] == 0) goto redoplace;
	if (game_mapm[(fruit_x + 1) + (fruit_y) * 38] == 0) goto redoplace;
	if (game_mapm[(fruit_x) + (fruit_y + 1) * 38] == 0) goto redoplace;
	if (game_mapm[(fruit_x + 1) + (fruit_y + 1) * 38] == 0) goto redoplace;
	if (game_map[(fruit_x) + (fruit_y) * 38] == 1) goto redoplace;
	if (game_map[(fruit_x + 1) + (fruit_y) * 38] == 1) goto redoplace;
	if (game_map[(fruit_x) + (fruit_y + 1) * 38] == 1) goto redoplace;
	if (game_map[(fruit_x + 1) + (fruit_y + 1) * 38] == 1) goto redoplace;
	u32 loop;
	for (loop = 0; loop < snake_len; loop++)
	{
		if (fruit_x == snake_pieces[loop].x && fruit_y == snake_pieces[loop].y) goto redoplace;
		if (fruit_x == snake_pieces[loop].x - 1 && fruit_y == snake_pieces[loop].y) goto redoplace;
		if (fruit_x == snake_pieces[loop].x && fruit_y == snake_pieces[loop].y - 1) goto redoplace;
		if (fruit_x == snake_pieces[loop].x - 1 && fruit_y == snake_pieces[loop].y - 1) goto redoplace;
	}
	if (fruit_x == rat_x && fruit_y == rat_y && rat_enable) goto redoplace;
	if (fruit_x == rat_x - 1 && fruit_y == rat_y && rat_enable) goto redoplace;
	if (fruit_x == rat_x && fruit_y == rat_y - 1 && rat_enable - 1) goto redoplace;
	if (fruit_x == rat_x - 1&& fruit_y == rat_y - 1 && rat_enable - 1) goto redoplace;
	if (fruit_x == power_x && fruit_y == power_y && power_enable) goto redoplace;
	if (fruit_x == power_x + 1 && fruit_y == power_y && power_enable) goto redoplace;
	if (fruit_x == power_x && fruit_y == power_y + 1 && power_enable) goto redoplace;
	if (fruit_x == power_x + 1 && fruit_y == power_y + 1 && power_enable) goto redoplace;
	if (fruit_x == power_x - 1 && fruit_y == power_y && power_enable) goto redoplace;
	if (fruit_x == power_x - 1 && fruit_y == power_y - 1 && power_enable) goto redoplace;
	if (fruit_x == power_x && fruit_y == power_y - 1 && power_enable) goto redoplace;
	if (fruit_x == power_x + 1 && fruit_y == power_y - 1 && power_enable) goto redoplace;
	if (fruit_x == power_x - 1 && fruit_y == power_y + 1 && power_enable) goto redoplace;
	fruit_type = rand() % 4;
	SetSprite_8x8(44 + fruit_x * 4, 36 + fruit_y * 4, 66 + fruit_type, 17);
	fruit_time = 600;
	fruit_enable = true;
}

void Fruit_Rid(void)
{
	// Delete the fruit
	SetSprite_8x8(240, 160, 0, 17);
}

void Fruit_Reset_Spawn(void)
{
	fruit_spawn_time = 1000 + rand() % 1000;
	fruit_enable = false;
}

void Snake_EatFruit(void)
{
	Snd_Stop();
	Snd_Beep(4, 0, 5, 5, 2, 5, 0, 0xF, 0x5C0);
	game_score += 100 * score_multi;
	game_redraw_stats();
	fruit_enable = false;
	Fruit_Rid();
	Fruit_Reset_Spawn();
	if (snake_len < snake_max - 3) snake_len += 3;
}

void Power_Place(void)
{
	// Put the powerup on the screen
redoplace:
	power_x = rand() % 37;
	power_y = rand() % 25;
	if (game_mapm[(power_x) + (power_y) * 38] == 0) goto redoplace;
	if (game_mapm[(power_x + 1) + (power_y) * 38] == 0) goto redoplace;
	if (game_mapm[(power_x) + (power_y + 1) * 38] == 0) goto redoplace;
	if (game_mapm[(power_x + 1) + (power_y + 1) * 38] == 0) goto redoplace;
	if (game_map[(power_x) + (power_y) * 38] == 1) goto redoplace;
	if (game_map[(power_x + 1) + (power_y) * 38] == 1) goto redoplace;
	if (game_map[(power_x) + (power_y + 1) * 38] == 1) goto redoplace;
	if (game_map[(power_x + 1) + (power_y + 1) * 38] == 1) goto redoplace;
	u32 loop;
	for (loop = 0; loop < snake_len; loop++)
	{
		if (power_x == snake_pieces[loop].x && power_y == snake_pieces[loop].y) goto redoplace;
		if (power_x == snake_pieces[loop].x - 1 && power_y == snake_pieces[loop].y) goto redoplace;
		if (power_x == snake_pieces[loop].x && power_y == snake_pieces[loop].y - 1) goto redoplace;
		if (power_x == snake_pieces[loop].x - 1 && power_y == snake_pieces[loop].y - 1) goto redoplace;
	}
	if (power_x == rat_x && power_y == rat_y && rat_enable) goto redoplace;
	if (power_x == rat_x - 1 && power_y == rat_y && rat_enable) goto redoplace;
	if (power_x == rat_x && power_y == rat_y - 1 && rat_enable) goto redoplace;
	if (power_x == rat_x - 1 && power_y == rat_y - 1 && rat_enable) goto redoplace;

	if (power_x == fruit_x && power_y == fruit_y && fruit_enable) goto redoplace;
	if (power_x == fruit_x + 1 && power_y == fruit_y && fruit_enable) goto redoplace;
	if (power_x == fruit_x && power_y == fruit_y + 1 && fruit_enable) goto redoplace;
	if (power_x == fruit_x + 1 && power_y == fruit_y + 1 && fruit_enable) goto redoplace;
	if (power_x == fruit_x - 1 && power_y == fruit_y && fruit_enable) goto redoplace;
	if (power_x == fruit_x - 1 && power_y == fruit_y - 1 && fruit_enable) goto redoplace;
	if (power_x == fruit_x && power_y == fruit_y - 1 && fruit_enable) goto redoplace;
	if (power_x == fruit_x + 1 && power_y == fruit_y - 1 && fruit_enable) goto redoplace;
	if (power_x == fruit_x - 1 && power_y == fruit_y + 1 && fruit_enable) goto redoplace;
	SetSprite_8x8(44 + power_x * 4, 36 + power_y * 4, 96, 18);
	power_time = 600;
	power_enable = true;
}

void Power_Rid(void)
{
	SetSprite_8x8(240, 160, 0, 18);
}

void Power_Reset_Spawn(void)
{
	power_spawn_time = 1500 + rand() % 1000;
	power_enable = false;
}

void Snake_GetPower(void)
{
	Snd_Stop();
	Snd_Beep(5, 0, 2, 2, 2, 6, 0, 0xF, 0x400);
	power_enable = false;
	Power_Rid();
	Power_Reset_Spawn();
#define powerup_max 39
	int r = rand() % (powerup_max + 1);
	bool bIsMulti = false;
	// Powerup Programming here:
	if (r == 0)
	{
		// 1-UP!
		SetSprite_32x8(100, 84, 416, 0);
		SetSprite_32x8(132, 84, 420, 1);
		game_lives++;
		game_redraw_stats();
	}
	else if (r >= 1 && r <= 6)
	{
		// FASTER!
		SetSprite_32x8(92, 84, 448, 0);
		SetSprite_32x8(124, 84, 452, 1);
		if (snake_speed < 80) snake_speed += 20;
		if (snake_speed > 80) snake_speed = 80;
	}
	else if (r >= 7 && r <= 12)
	{
		// SLOWER
		SetSprite_32x8(96, 84, 480, 0);
		SetSprite_32x8(128, 84, 484, 1);
		if (snake_speed > 40) snake_speed -= 20;
		if (snake_speed < 40) snake_speed = 40;
	}
	else if (r >= 13 && r <= 22)
	{
		// +10
		SetSprite_32x8(108, 84, 512, 0);
		//SetSprite_32x8(, 84, 420, 1);
		game_score += 10 * score_multi;
		game_redraw_stats();
	}
	else if (r >= 23 && r <= 25)
	{
		// +50
		SetSprite_32x8(108, 84, 544, 0);
		//SetSprite_32x8(, 84, 420, 1);
		game_score += 50 * score_multi;
		game_redraw_stats();
	}
	else if (r >= 26 && r <= 27)
	{
		// +100
		SetSprite_32x8(104, 84, 576, 0);
		//SetSprite_32x8(, 84, 484, 1);
		game_score += 100 * score_multi;
		game_redraw_stats();
	}
	else if (r >= 28 && r <= 29)
	{
		// +200
		SetSprite_32x8(104, 84, 608, 0);
		//SetSprite_32x8(, 84, 484, 1);
		game_score += 200 * score_multi;
		game_redraw_stats();
	}
	else if (r == 30)
	{
		// +500!
		SetSprite_32x8(100, 84, 640, 0);
		SetSprite_32x8(132, 84, 644, 1);
		game_score += 500 * score_multi;
		game_redraw_stats();
	}
	else if (r >= 31 && r <= 35)
	{
		// x2 - x5 - x10
		switch (score_multi_old)
		{
		case 1:
			score_multi = 2;
			score_multi_old = 2;
			SetSprite_32x8(112, 84, 672, 0);
			//SetSprite_32x8(132, 84, 644, 1);
			break;
		case 2:
			score_multi = 5;
			score_multi_old = 5;
			SetSprite_32x8(112, 84, 704, 0);
			//SetSprite_32x8(132, 84, 644, 1);
			break;
		case 5:
			score_multi = 10;
			score_multi_old = 10;
			SetSprite_32x8(108, 84, 736, 0);
			//SetSprite_32x8(132, 84, 644, 1);
		}
		score_multi_time = 750;
		bIsMulti = true;
		score_multi_streak = true;
	}
	else if (r >= 36 && r <= 39)
	{
		// LONGER
		SetSprite_32x8(92, 84, 768, 0);
		SetSprite_32x8(124, 84, 772, 1);
		if (snake_len < 500 - 5) snake_len += 6;
	}
	if (!bIsMulti)
	{
		score_multi_old = 1;
		score_multi_streak = false;
	}
	bGetPower = true;
	getpower_time = 150;
}


