// BYTES by eKid
// ....special thanks to www.belogic.com for their sound tutorials
// also thanx to all the #gbadev'rs for their help
// Kojote, for hosting the competition

// WWW.CONSOLEFEVER.COM for sponsoring this compo

// Keep in mind, when you look at all this source... it works, but it's not very neat!
// Also, I got tired of commenting stuff, so you may notice that only 10% is commented

// SWI function
#if defined ( __thumb__ ) || defined( CODE16 )
#define SystemCall(Number)   asm ("SWI    "#Number)
#else
#define SystemCall(Number)   asm ("SWI    "#Number" << 16")
#endif

//typedef unsigned char bool;
#define bool unsigned char
#define true 1
#define false 0
//typedef enum bool {true, false};

#include <stdlib.h> // Standard library

#include "gba.h" // Register definitions, Useful functions..etc..

#include "font_sizes.h" // Font size table
#include "color_bg.h" // BG color table


#include "names.h" // Names for the highscore reset function
u16 max_names = 24;

// Graphic headers:
#include "gfx\gfx_eKidP.h"
#include "gfx\gfx_spray1.h"
#include "gfx\gfx_spray2.h"
#include "gfx\gfx_warp.h"
#include "gfx\gfx_stars.h"
#include "gfx\gfx_title.h"
#include "gfx\gfx_blank.h"
#include "gfx\gfx_point.h"
#include "gfx\gfx_options.h"
#include "gfx\gfx_bgpick.h"
#include "gfx\gfx_sndpick.h"
#include "gfx\gfx_font.h"
#include "gfx\gfx_greatsnake.h"
#include "gfx\gfx_enter_name.h"
#include "gfx\gfx_pause.h"

#include "gfx\game\gfx_game_blocks.h"
#include "gfx\game\gfx_game_fruit.h"
#include "gfx\game\gfx_game_life.h"
#include "gfx\game\gfx_game_numb.h"
#include "gfx\game\gfx_game_pickup.h"
#include "gfx\game\gfx_game_rat.h"
#include "gfx\game\gfx_game_shell.h"
#include "gfx\game\gfx_game_start.h"
#include "gfx\game\gfx_game_ready.h"
#include "gfx\game\gfx_game_over.h"
#include "gfx\game\gfx_highscore.h"
	
#include "gfx\game\power\gfx_pu_1up.h"
#include "gfx\game\power\gfx_pu_faster.h"
#include "gfx\game\power\gfx_pu_slower.h"
#include "gfx\game\power\gfx_pu_10p.h"
#include "gfx\game\power\gfx_pu_50p.h"
#include "gfx\game\power\gfx_pu_100p.h"
#include "gfx\game\power\gfx_pu_200p.h"
#include "gfx\game\power\gfx_pu_500p.h"
#include "gfx\game\power\gfx_pu_x2.h"
#include "gfx\game\power\gfx_pu_x5.h"
#include "gfx\game\power\gfx_pu_x10.h"
#include "gfx\game\power\gfx_pu_longer.h"

// Maps
#include "maps\map_level0.h"
#include "maps\map_level1.h"
#include "maps\map_level2.h"
#include "maps\map_level3.h"
#include "maps\map_level4.h"
#include "maps\map_level5.h"
#include "maps\map_level6.h"
#include "maps\map_level7.h"
const u8* maparr[] = {&map_level0[0], &map_level1[0], &map_level2[0], &map_level3[0], &map_level4[0], &map_level5[0], &map_level6[0], &map_level7[0]};
#define max_map 7 // number of maps - 1

#define rgb16(r,g,b) r + (g << 5) + (b << 10) // 0-31 rgb function
#define rgb24(r,g,b) (r >> 3) + ((g >> 3) << 5) + ((b >> 3) << 10) // 0-255 rgb function

void AgbMain(void); // Main Functions
void copy2obj(u8* src, u16* objentry, int width, int height, bool bSolid); // A function for copying data to video ram
void WaitForVSync(void); // A function to wait for the VBlank
void AddSprite_8x8(int x, int y, u16 c); //          SPRITE FUNCTIONS: 
void AddSprite_16x16(int x, int y, u16 c); //                          |
void AddSprite_8x16(int x, int y, u16 c); //                           |
void AddSprite_32x16(int x, int y, u16 c); //                          |
void SetSprite_8x8(int x, int y, u16 c, u16 entry); //                 |
void SetSprite_64x64(int x, int y, u16 c, u16 entry); //               |
void SetSprite_32x8(int x, int y, u16 c, u16 entry); //                |
void SetSprite_16x8(int x, int y, u16 c, u16 entry); //                /
void CopyOAM(void); // OAM copier
void SetBGColor(u16 color); // Sets the background color

void ClearSprites(void); // Clears all sprites

void Snd_Beep(u16 sweepshifts, u16 sweepdir, u16 sweeptime, u16 soundlength, u16 waveduty, u16 envsteptime, u16 envdir, u16 envinit, u16 sfreq); // Beeper function
void Snd_Stop(void); // Stops all sound

void Options_Show(void); // Options screen
void Options_GetInput(void); // Options screen GetInput function

void Intro(void); // Intro entry point
void Intro_getinput(void); // Intro GetInput function

void SaveGame(void); // Saves all progress
void LoadGame(void); // Loads all progress

void Highscore_Show(void); // Shows the great snakes screen
void hs_getinput(void); // GetInput for that screen
int hs_DrawString(int x, int y, char* str, bool rmzero); // Draws a string
void hs_Redraw(void); // Redraws everything in great snakes screen

bool Check_HighScore(u32 score); // Returns true if given a highscore
void Add_HighScore(char* Name, u32 score); // Adds a highscore to the database
void Reset_Scores(void); // Resets all the highscores
void Save_Scores(void); // Saves the highscores
void Load_Scores(void); // Loads the highscores

void Start_Game(void); // Ingame entry point
void game_ResetCounters(void); // Resets the ingame status
void game_reset_bg(void); // Resets the ingame screen background

void Enter_Highscore(void); // Shows the "Enter your name" screen

u16 rand_init = 0; // srand() variable
u8 cur_sprite = 0; // points to a new sprite when using the AddSprite functions

#include "Scores.h" // Score controller
#include "Options.h" // Options screen controller
#include "Sound.h" // Sound controller
#include "Intro.h" // Intro controller
#include "greatsnakes.h" // Highscore screen controller
#include "Ingame.h" // Ingame controller
#include "hs_entry.h" // "Enter your name" screen

void InterruptProcess(void) __attribute__ ((section(".iwram"))); // Interrupt function

void InterruptProcess(void)
{
	REG_IF |= REG_IF;
}

void SaveGame(void)
{
	// Save the important variables
	SRAM[0] = (u8)OPTIONS_BGCOLOR;
	SRAM[1] = (u8)OPTIONS_SOUND;
	Save_Scores(); // Save scores
}

void LoadGame(void)
{
	if (!(SRAM[2] == 1 && SRAM[5] == 78 && SRAM[6] == 34 && SRAM[7] == 99)) // Set default options
	{
		// Reset all options
		SRAM[0] = 0;
		SRAM[1] = 1;
		SRAM[2] = 1;
		SRAM[3] = 0;
		SRAM[4] = 0;
		SRAM[5] = 78;
		SRAM[6] = 34;
		SRAM[7] = 99;
		Reset_Scores();
		Save_Scores();
	}
	// Initialize randomizer
	rand_init = SRAM[3] + SRAM[4] * 256;
	rand_init++;
	srand(rand_init);
	// save randomizer number
	SRAM[3] = rand_init & 0xFF;
	SRAM[4] = rand_init >> 8;
	OPTIONS_BGCOLOR = SRAM[0];
	OPTIONS_SOUND = SRAM[1];
	SetBGColor(color_bg[OPTIONS_BGCOLOR]);
	Load_Scores(); // Load scores
}

void SetBGColor(u16 color)
{
	// Set the BG color
	BGPaletteMem[1]  = color;
	OBJPaletteMem[0] = color;
	BGPaletteMem[3]  = color;
	OBJPaletteMem[2] = color;
	BGPaletteMem[16] = color;
	BGPaletteMem[17] = 0;
}

void copy2obj(u8* src, u16* objentry, int width, int height, bool bSolid)
{
	int x, y;
	int x2, y2;
	// yeah, yeah, so this code looks messy ;)
	for (x2 = 0; x2 < width / 8; x2++)
	{
		for (y2 = 0; y2 < height / 8; y2++)
		{
			for (x = 0; x < 8; x++)
			{
				for (y = 0; y < 8; y++)
				{
					objentry[x2 * 16 + y2 * 512 + (x / 4) + y * 2] &= 0xFFFF - (0xF << ((x & 3) * 4));
					objentry[x2 * 16 + y2 * 512 + (x / 4) + y * 2] |= (u16)((((src[x2 + (y2 * 8 + y) * (width/8)] >> x) & 1) + (2 * bSolid)) << ((x & 3) * 4));
				}
			}
		}
	}

}

void AgbMain(void)
{
	// Enable Vertical Blank interrupt
	REG_IE |= INT_VBLANK;
	REG_DISPSTAT |= BIT3;
	REG_IME = 1;
	// Set the colors to black & white
	BGPaletteMem[0] = rgb16(0, 0, 0);
	BGPaletteMem[1] = rgb16(31, 31, 31);
	OBJPaletteMem[1] = rgb16(0, 0, 0);
	OBJPaletteMem[0] = rgb16(31, 31, 31);
	BGPaletteMem[2] = rgb16(0, 0, 0);
	BGPaletteMem[3] = rgb16(31, 31, 31);
	OBJPaletteMem[3] = rgb16(0, 0, 0);
	OBJPaletteMem[2] = rgb16(31, 31, 31);
	Intro(); // Do the intro
}

void ClearSprites(void)
{
	int loop;
	for (loop = 0; loop < 128; loop++)
	{
		// Set the sprites to offscreen
		sprites[loop].attribute0 = 160;
		sprites[loop].attribute1 = 240;
		sprites[loop].attribute2 = 0;
		sprites[loop].attribute3 = 0;
	}
	cur_sprite = 0;
}

// These functions will edit the sprites[] variable

void SetSprite_8x8(int x, int y, u16 c, u16 entry)
{
	sprites[entry].attribute0 = y;
	sprites[entry].attribute1 = x;
	sprites[entry].attribute2 = c;
}

void SetSprite_64x64(int x, int y, u16 c, u16 entry)
{
	sprites[entry].attribute0 = y;
	sprites[entry].attribute1 = x | SIZE_64;
	sprites[entry].attribute2 = c;
}

void AddSprite_8x8(int x, int y, u16 c)
{
	sprites[cur_sprite].attribute0 = y;
	sprites[cur_sprite].attribute1 = x;
	sprites[cur_sprite].attribute2 = c;
	cur_sprite++;
}

void AddSprite_16x16(int x, int y, u16 c)
{
	sprites[cur_sprite].attribute0 = y;
	sprites[cur_sprite].attribute1 = x | SIZE_16;
	sprites[cur_sprite].attribute2 = c;
	cur_sprite++;
}

void AddSprite_8x16(int x, int y, u16 c)
{
	sprites[cur_sprite].attribute0 = y | TALL;
	sprites[cur_sprite].attribute1 = x;
	sprites[cur_sprite].attribute2 = c;
	cur_sprite++;
}

void AddSprite_32x16(int x, int y, u16 c)
{
	sprites[cur_sprite].attribute0 = y | WIDE;
	sprites[cur_sprite].attribute1 = x | SIZE_32;
	sprites[cur_sprite].attribute2 = c;
	cur_sprite++;
}

void SetSprite_32x8(int x, int y, u16 c, u16 entry)
{
	sprites[entry].attribute0 = y | WIDE;
	sprites[entry].attribute1 = x | SIZE_16;
	sprites[entry].attribute2 = c;
}

void SetSprite_16x8(int x, int y, u16 c, u16 entry)
{
	sprites[entry].attribute0 = y | WIDE;
	sprites[entry].attribute1 = x;
	sprites[entry].attribute2 = c;
}

void WaitForVSync(void)
{	
	// Halt the system, it will wake up when an interrupt occurs
	// There is only one interrupt enabled, the VBlank interrupt, so I just need to simply call SWI 2 (halt)
	SystemCall(2);
}

void CopyOAM(void)
{
	// Copy the sprites[] variable to 0x7000000 (OAM)
	DMA_Copy(3, (void*)sprites, (void*)0x7000000, 128*4, DMA_16NOW);
}
